clear all;
%warning off;

% datatype: type of training data desired
datatype = 3;	% Mackey-Glass Series Prediction
[n0,n1,n2,nltype1,nltype2,x,d,dc] = generatedata(datatype);
if datatype == 6,load laserdata.mat,elseif datatype == 7,load enginedata.mat,elseif datatype == 8,load dowjonesdata.mat,x = x/1000;d = d/1000;end,

W=eye(n2);	% weight matrix for MSE
indicator = 0;
maxiter_ls = 3;	 % if 'indicator==0' then this value set to 3 in mlp_desiredbp automatically
if datatype == 6,maxiter_bp = 1000;eta = 1e-2;maxiter_lsbp = 250;elseif datatype == 7,maxiter_bp = 200;eta = 1e-4;maxiter_lsbp = 50;elseif datatype == 8,maxiter_bp = 2000;eta = 1e-1;maxiter_lsbp = 500;end,

for mc = 1:1;
   loopt0 = clock;mc
   % generate random initial weight matrices
	W1a(:,:,mc) = 0.1*randn(n1,n0);b1a(:,mc) = 0.1*randn(n1,1);W2a(:,:,mc) = 0.1*randn(n2,n1);b2a(:,mc) = 0.1*randn(n2,1);
   W10 = W1a(:,:,mc);b10 = b1a(:,mc);W20 = W2a(:,:,mc);b20 = b2a(:,mc); 
   % obtain optimal weights using backpropagation of desired signal
   [W1_ls(:,:,mc),b1_ls(:,mc),W2_ls(:,:,mc),b2_ls(:,mc),J_ls(1,mc),iter_ls(1,mc)] = mlp_desiredbp(x,d,W10,b10,W20,b20,maxiter_ls,nltype1,nltype2,W,indicator,1);
   % continue training over ls solutions using standard backpropagation
   %[W1_lsbp(:,:,mc),b1_lsbp(:,mc),W2_lsbp(:,:,mc),b2_lsbp(:,mc),J_lsbp(1,mc)] = mlp_msebp1(x,d,W1_ls(:,:,mc),b1_ls(:,mc),W2_ls(:,:,mc),b2_ls(:,mc),maxiter_lsbp,nltype1,nltype2,W,2,eta);
   % obtain optimal weights using standard backpropagation starting from original initial weights
   %[W1_bp(:,:,mc),b1_bp(:,mc),W2_bp(:,:,mc),b2_bp(:,mc),J_bp(1,mc)] = mlp_msebp1(x,d,W10,b10,W20,b20,maxiter_bp,nltype1,nltype2,W,3,eta);   
   if datatype == 6,save laseriter.mat,elseif datatype == 7,save engineiter.mat,elseif datatype == 8,save dowjiter.mat,end,
   etime(clock,loopt0)
end